load dat[]=stockandyogo.raw.lev;
data=reshape(dat,rows(dat)/4,4);

/*Note: the exogenous regressors have rank of 86, and there are 
        4 instruments*/

E=data[.,1:2];
F=data[.,3:4];

sigmaVV=E'E/(rows(data)-86-4);

YPY=F'F;

L=chol(sigmaVV);
C=inv(L)';

G=C'YPY*C/4;
gmin=minc(eig(G));
"Stock and Yogo statistic, Levitt measure:";;
gmin;

load dat[]=stockandyogo.raw.mcc;
data=reshape(dat,rows(dat)/4,4);

/*Note: the exogenous regressors have rank of 86, and there are 
        4 instruments*/

E=data[.,1:2];
F=data[.,3:4];

sigmaVV=E'E/(rows(data)-86-4);

YPY=F'F;

L=chol(sigmaVV);
C=inv(L)';

G=C'YPY*C/4;
gmin=minc(eig(G));
"Stock and Yogo statistic, McCrary measure:";;
gmin;

/*gmin appears to be roughly 6.  This suggests that the maximal bias
of 2SLS, relative to OLS, is near 20%, and that the the maximal
size distortion of a Wald test based on 2SLS estimates is
25%--i.e. use of a 5% critical value could lead one to reject a true
null fully 30% of the time.*/
